package org.nl.acs.device.service;

import org.nl.acs.common.base.PageInfo;
import org.nl.acs.common.base.CommonService;
import org.nl.acs.device.domain.DeviceErpmapping;
import org.nl.acs.device.service.dto.AcsDeviceErpmappingDto;
import org.nl.acs.device.service.dto.DeviceErpmappingQueryParam;
import org.springframework.data.domain.Pageable;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
* @author jiaolm
* @date 2023-05-09
*/
public interface DeviceErpmappingService extends CommonService<DeviceErpmapping>  {

    static final String CACHE_KEY = "deviceErpmapping";

    /**
    * 查询数据分页
    * @param query 条件
    * @param pageable 分页参数
    * @return PageInfo<DeviceErpmappingDto>
    */
    PageInfo<AcsDeviceErpmappingDto> queryAll(DeviceErpmappingQueryParam query, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param query 条件参数
    * @return List<DeviceErpmappingDto>
    */
    List<AcsDeviceErpmappingDto> queryAll(DeviceErpmappingQueryParam query);

    DeviceErpmapping getById(String id);
    AcsDeviceErpmappingDto findById(String id);

    /**
     * 插入一条新数据。
     */
    int insert(AcsDeviceErpmappingDto resources);
    int updateById(AcsDeviceErpmappingDto resources);
    int removeById(String id);
    int removeByIds(Set<String> ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    // void download(List<DeviceErpmappingDto> all, HttpServletResponse response) throws IOException;
    /**
     * 查询数据分页
     *
     * @param whereJson 条件
     * @param page      分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryAll(Map whereJson, Pageable page);

    /**
     * 查询所有数据不分页
     *
     * @param whereJson 条件参数
     * @return List<AcsDeviceErpmappingDto>
     */
    List<AcsDeviceErpmappingDto> queryAll(Map whereJson);

    /**
     * 根据ID查询
     *
     * @param device_id ID
     * @return AcsDeviceErpmapping
     */
//    AcsDeviceErpmappingDto findById(String device_id);

    /**
     * 根据编码查询
     *
     * @param code code
     * @return AcsDeviceErpmapping
     */
//    AcsDeviceErpmappingDto findByCode(String code);


    /**
     * 创建
     *
     * @param dto /
     */
    void create(AcsDeviceErpmappingDto dto);

    /**
     * 编辑
     *
     * @param dto /
     */
    void update(AcsDeviceErpmappingDto dto);

    /**
     * 多选删除
     *
     * @param ids /
     */
    void deleteAll(String[] ids);

    /**
     * 导出数据
     *
     * @param dtos     待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<AcsDeviceErpmappingDto> dtos, HttpServletResponse response) throws IOException;
}
